Index: /branches/network/src/lib/network/synchronizeable_var/synchronizeable_var.cc
===================================================================
--- /branches/network/src/lib/network/synchronizeable_var/synchronizeable_var.cc	(revision 7444)
+++ /branches/network/src/lib/network/synchronizeable_var/synchronizeable_var.cc	(revision 7444)
@@ -0,0 +1,63 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Christoph Renner
+   co-programmer: ...
+*/
+
+
+#include "synchronizeable_var.h"
+
+
+/**
+ * standard constructor
+ * @todo this constructor is not jet implemented - do it
+*/
+SynchronizeableVar::SynchronizeableVar ( void * ptrIn, void * ptrOut, std::string name, int length, int permission, int priority)
+{
+  this->ptrIn = ptrIn;
+  this->ptrOut = ptrOut;
+  this->length = length;
+  this->permission = permission;
+  this->priority = priority;
+  this->real_priority = priority;
+  this->name = name;
+}
+
+
+/**
+ * standard deconstructor
+*/
+SynchronizeableVar::~SynchronizeableVar ()
+{
+}
+
+/**
+ * write var data to byte buffer
+ * @param buf pointer to write to
+ * @param maxLength writeToBuf will not write more than maxLength bytes
+ * @return number bytes written
+ */
+int SynchronizeableVar::writeToBuf( byte * buf, int maxLength )
+{
+#warning implement this
+}
+
+/**
+ * read var data from byte buffer
+ * @param buf pointer to read from
+ * @param maxLength readFromBuf will not read more than maxLength bytes
+ * @return number bytes read
+ */
+int SynchronizeableVar::readFromBuf( byte * buf, int maxLength )
+{
+#warning implement this
+}
Index: /branches/network/src/lib/network/synchronizeable_var/synchronizeable_var.h
===================================================================
--- /branches/network/src/lib/network/synchronizeable_var/synchronizeable_var.h	(revision 7444)
+++ /branches/network/src/lib/network/synchronizeable_var/synchronizeable_var.h	(revision 7444)
@@ -0,0 +1,62 @@
+/*!
+ * @file synchronizeable_var.h
+ * @brief Definition of SynchronizeableVar
+*/
+
+#ifndef _SYNCHRONIZEABLE_VAR_H
+#define _SYNCHRONIZEABLE_VAR_H
+
+#include <string>
+#include "netdefs.h"
+
+class SynchronizeableVar {
+
+  public:
+    SynchronizeableVar( void * ptrIn, void * ptrOut, std::string name, int length, int permission = 0, int priority = 0 );
+    virtual ~SynchronizeableVar();
+    
+    /**
+     * check if synchronizeable wants to be informed on changes
+     * @return true if synchronizeable wants to be informed on changes
+     */
+    inline bool beWatched(){ return this->bWatched; }
+    
+    virtual int writeToBuf( byte * buf, int maxLength );
+    virtual int readFromBuf( byte * buf, int maxLength );
+    
+    /**
+     * check for permission to write
+     * @return true if you can write
+     */
+    inline bool checkPremission( int permission ){ return (permission & this->permission) != 0; }
+    
+    /**
+     * get variable name
+     * @return name
+     */
+    inline std::string getName(){ return name; }
+    
+    /**
+     * set variable name
+     * @param name new name
+     */
+    inline void setName( std::string name ) { this->name = name; }
+
+
+  private:
+    bool bWatched;      //!< true if synchronizeable wants to be informed on changes
+
+  protected:
+    void * ptrIn;       //!< pointer to data (read)
+    void * ptrOut;      //!< pointer to data (write)
+    int length;         //!< data length
+    int permission;     //!< who is allowed to change this var
+    int priority;       //!< priority assigned to var
+    int real_priority;  //!< priority assigned to var, increased every time not sent
+    
+    
+    std::string name;    //!< variable name (for debugging)
+
+};
+
+#endif /* _PROTO_CLASS_H */
Index: /branches/network/src/lib/network/synchronizeable_var/synchronizeable_vector.cc
===================================================================
--- /branches/network/src/lib/network/synchronizeable_var/synchronizeable_vector.cc	(revision 7444)
+++ /branches/network/src/lib/network/synchronizeable_var/synchronizeable_vector.cc	(revision 7444)
@@ -0,0 +1,58 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Christoph Renner
+   co-programmer: ...
+*/
+
+
+#include "synchronizeable_vector.h"
+
+
+/**
+ * standard constructor
+ * @todo this constructor is not jet implemented - do it
+*/
+SynchronizeableVector::SynchronizeableVector( Vector * ptrIn, Vector * ptrOut, std::string name, int permission, int priority) : SynchronizeableVar( ptrIn, ptrOut, name, 0, permission, priority )
+{
+  this->vPtrIn = ptrIn;
+  this->vPtrOut = ptrOut;
+}
+
+
+/**
+ * standard deconstructor
+*/
+SynchronizeableVector::~SynchronizeableVector ()
+{
+}
+
+/**
+ * write var data to byte buffer
+ * @param buf pointer to write to
+ * @param maxLength writeToBuf will not write more than maxLength bytes
+ * @return number bytes written
+ */
+int SynchronizeableVector::writeToBuf( byte * buf, int maxLength )
+{
+#warning implement this
+}
+
+/**
+ * read var data from byte buffer
+ * @param buf pointer to read from
+ * @param maxLength readFromBuf will not read more than maxLength bytes
+ * @return number bytes read
+ */
+int SynchronizeableVector::readFromBuf( byte * buf, int maxLength )
+{
+#warning implement this
+}
Index: /branches/network/src/lib/network/synchronizeable_var/synchronizeable_vector.h
===================================================================
--- /branches/network/src/lib/network/synchronizeable_var/synchronizeable_vector.h	(revision 7444)
+++ /branches/network/src/lib/network/synchronizeable_var/synchronizeable_vector.h	(revision 7444)
@@ -0,0 +1,28 @@
+/*!
+ * @file synchronizeable_vector.h
+ * @brief Definition of SynchronizeableVector
+*/
+
+#include "synchronizeable_var/synchronizeable_var.h"
+
+#ifndef _SYNCHRONIZEABLE_VECTOR_H
+#define _SYNCHRONIZEABLE_VECTOR_H
+
+#include "vector.h"
+
+class SynchronizeableVector : public SynchronizeableVar {
+
+  public:
+    SynchronizeableVector( Vector * ptrIn, Vector * ptrOut, std::string name, int permission = 0, int priority = 0 );
+    virtual ~SynchronizeableVector();
+    
+    virtual int writeToBuf( byte * buf, int maxLength );
+    virtual int readFromBuf( byte * buf, int maxLength );
+    
+  private:
+    Vector * vPtrIn;       //!< pointer to data (read)
+    Vector * vPtrOut;      //!< pointer to data (write)
+
+};
+
+#endif /* _PROTO_CLASS_H */
Index: /branches/network/src/util/multiplayer_team_deathmatch.cc
===================================================================
--- /branches/network/src/util/multiplayer_team_deathmatch.cc	(revision 7443)
+++ /branches/network/src/util/multiplayer_team_deathmatch.cc	(revision 7444)
@@ -203,10 +203,7 @@
       if ( terrz < terrain->getHeight( terrx, terry ) && ss->getAbsCoor().x > -1000 )
       {
-        //PRINTF(0)("COLLLLLLIIIIIDDDDEEEE\n");
-        ss->networkCollisionList.push_back( 1234567890 );
-        ss->doCollideNetwork( 1234567890 );
+        //TODO handle this
       }
-      //PRINTF(0)("x = %f, y = %f, z = %f, height = %f\n", terrx, terry, terrz, terrain->getHeight( terrx, terry ));
-      //ss->setRelCoorSoft( ss->getAbsCoor().x, terrain->getHeight( terrx, terry )-offsety, ss->getAbsCoor().z );
+
 
       float dist = (dynamic_cast<Playable*>(*it)->getAbsCoor() - big_left).len();
@@ -222,6 +219,5 @@
         if((*it)->isA(CL_SPACE_SHIP))
         {
-          dynamic_cast<SpaceShip*>(*it)->networkCollisionList.push_back(1163692);
-          dynamic_cast<SpaceShip*>(*it)->doCollideNetwork(11636922);
+          //TODO handle this
         }
       }
Index: /branches/network/src/world_entities/environments/water.cc
===================================================================
--- /branches/network/src/world_entities/environments/water.cc	(revision 7443)
+++ /branches/network/src/world_entities/environments/water.cc	(revision 7444)
@@ -59,4 +59,10 @@
   // To test the Wave equation
   //this->wave(5.0,4.0, 1, 10);
+  
+  height_handle = registerVarId( new SynchronizeableFloat( &height, &height, "height" ) );
+  resX_handle = registerVarId( new SynchronizeableUInt( &resX, &resX, "resX" ) );
+  resY_handle = registerVarId( new SynchronizeableUInt( &resY, &resY, "resY" ) );
+  sizeX_handle = registerVarId( new SynchronizeableFloat( &sizeX, &sizeX, "sizeX" ) );
+  sizeY_handle = registerVarId( new SynchronizeableFloat( &sizeY, &sizeY, "sizeY" ) );
 }
 
@@ -291,116 +297,19 @@
 
 
-/**
- * Writes data from network containing information about the state
- * @param data pointer to data
- * @param length length of data
- * @param sender hostID of sender
- */
-int Water::writeBytes( const byte * data, int length, int sender )
-{
-  setRequestedSync( false );
-  setIsOutOfSync( false );
-
-  SYNCHELP_READ_BEGIN();
-
-  SYNCHELP_READ_FKT( Water::writeState, NWT_WAT_STATE );
-
-  return SYNCHELP_READ_N;
-}
-
-
-/**
- * data copied in data will bee sent to another host
- * @param data pointer to data
- * @param maxLength max length of data
- * @return the number of bytes writen
- */
-int Water::readBytes( byte * data, int maxLength, int * reciever )
-{
-  SYNCHELP_WRITE_BEGIN();
-
-  if ( isOutOfSync() && !requestedSync() && this->getHostID()!=this->getOwner() )
-  {
-    (NetworkGameManager::getInstance())->sync( this->getUniqueID(), this->getOwner() );
-    setRequestedSync( true );
-  }
-
-  int rec = this->getRequestSync();
-  if ( rec > 0 )
-  {
-    *reciever = rec;
-    SYNCHELP_WRITE_FKT( Water::readState, NWT_WAT_STATE );
-  }
-
-  *reciever = 0;
-  return SYNCHELP_WRITE_N;
-}
-
-
-
-/**
- * data copied in data will bee sent to another host
- * @param data pointer to data
- * @param maxLength max length of data
- * @return the number of bytes writen
- */
-int Water::readState( byte * data, int maxLength )
-{
-  SYNCHELP_WRITE_BEGIN();
-
-  SYNCHELP_WRITE_FKT( WorldEntity::readState, NWT_WAT_WE_STATE );
-
-  // sync the size
-  SYNCHELP_WRITE_FLOAT( this->sizeX, NWT_WAT_SIZEX );
-  SYNCHELP_WRITE_FLOAT( this->sizeY, NWT_WAT_SIZEY );
-
-  //sync resolution
-  SYNCHELP_WRITE_INT( this->resX, NWT_WAT_RESX );
-  SYNCHELP_WRITE_INT( this->resY, NWT_WAT_RESY );
-
-  //sync the height
-  SYNCHELP_WRITE_FLOAT( this->height, NWT_WAT_HEIGHT );
-
-  return SYNCHELP_WRITE_N;
-}
-
-
-/**
- * Writes data from network containing information about the state
- * @param data pointer to data
- * @param length length of data
- * @param sender hostID of sender
- */
-int Water::writeState( const byte * data, int length, int sender )
-{
-  SYNCHELP_READ_BEGIN();
-
-  SYNCHELP_READ_FKT( WorldEntity::writeState, NWT_WAT_WE_STATE );
-
-  float f1, f2;
-  int i1, i2;
-
-  //read the size
-  SYNCHELP_READ_FLOAT( f1, NWT_WAT_SIZEX );
-  SYNCHELP_READ_FLOAT( f2, NWT_WAT_SIZEY );
-  this->sizeX = f1;
-  this->sizeY = f2;
-  PRINTF(0)("Setting Water to size: %f x %f\n", f1, f2);
-
-  //read the resolution
-  SYNCHELP_READ_INT( i1, NWT_WAT_RESX );
-  SYNCHELP_READ_INT( i2, NWT_WAT_RESY );
-  this->resX = i1;
-  this->resY = i2;
-  PRINTF(0)("Setting Water to resolution: %i x %i\n", i1, i2);
-
-  //read the height
-  SYNCHELP_READ_FLOAT( f1, NWT_WAT_HEIGHT );
-  this->height = f1;
-
-  this->rebuildGrid();
-
-  return SYNCHELP_READ_N;
-}
-
-
+
+/**
+ * function to handle changes in synced vars
+ * @param id ids which have changed
+ */
+void Water::varChangeHandler( std::list< int > & id )
+{
+  if ( std::find( id.begin(), id.end(), height_handle ) != id.end() ||
+       std::find( id.begin(), id.end(), resX_handle ) != id.end() ||
+       std::find( id.begin(), id.end(), resY_handle ) != id.end() ||
+       std::find( id.begin(), id.end(), sizeX_handle ) != id.end() ||
+       std::find( id.begin(), id.end(), sizeY_handle ) != id.end()
+     )
+  {
+    this->rebuildGrid();
+  }
+}
Index: /branches/network/src/world_entities/environments/water.h
===================================================================
--- /branches/network/src/world_entities/environments/water.h	(revision 7443)
+++ /branches/network/src/world_entities/environments/water.h	(revision 7444)
@@ -38,10 +38,6 @@
    void draw() const;
    void tick(float dt);
-
-   virtual int writeBytes(const byte* data, int length, int sender);
-   virtual int readBytes(byte* data, int maxLength, int * reciever);
-
-   int writeState( const byte * data, int length, int sender );
-   int readState( byte * data, int maxLength );
+   
+   virtual void varChangeHandler( std::list<int> & id );
 
   private:
@@ -56,8 +52,14 @@
     Material        waterMaterial;
     Shader*         waterShader;
+    
     float           height;          //!< The hight of the Water
+    int             height_handle;   //!< Handle to notify about changes of height
 
-    unsigned int    resX, resY;
-    float           sizeX, sizeY;
+    unsigned int    resX, resY;      //!< Grid resolution
+    int             resX_handle;     //!< Handle to notify about changes of resX
+    int             resY_handle;     //!< Handle to notify about changes of resY
+    float           sizeX, sizeY;    //!< waters size
+    int             sizeX_handle;    //!< Handle to notify about changes of sizeX
+    int             sizeY_handle;    //!< Handle to notify about changes of sizeY
 
     float phase;
Index: /branches/network/src/world_entities/npcs/ground_turret.cc
===================================================================
--- /branches/network/src/world_entities/npcs/ground_turret.cc	(revision 7443)
+++ /branches/network/src/world_entities/npcs/ground_turret.cc	(revision 7444)
@@ -180,49 +180,2 @@
   Explosion::explode(this, Vector(10,10,10));
 }
-
-/**
- * Writes data from network containing information about the state
- * @param data pointer to data
- * @param length length of data
- * @param sender hostID of sender
- */
-int GroundTurret::writeBytes( const byte * data, int length, int sender )
-{
-  setRequestedSync( false );
-  setIsOutOfSync( false );
-
-  SYNCHELP_READ_BEGIN();
-
-  SYNCHELP_READ_FKT( WorldEntity::writeState, NWT_GT_WE_STATE );
-
-  return SYNCHELP_READ_N;
-}
-
-/**
- * data copied in data will bee sent to another host
- * @param data pointer to data
- * @param maxLength max length of data
- * @return the number of bytes writen
- */
-int GroundTurret::readBytes( byte * data, int maxLength, int * reciever )
-{
-  SYNCHELP_WRITE_BEGIN();
-
-  if ( isOutOfSync() && !requestedSync() && this->getHostID()!=this->getOwner() )
-  {
-    (NetworkGameManager::getInstance())->sync( this->getUniqueID(), this->getOwner() );
-    setRequestedSync( true );
-  }
-
-  int rec = this->getRequestSync();
-  if ( rec > 0 )
-  {
-    *reciever = rec;
-
-    SYNCHELP_WRITE_FKT( WorldEntity::readState, NWT_GT_WE_STATE );
-
-  }
-
-  *reciever = 0;
-  return SYNCHELP_WRITE_N;
-}
Index: /branches/network/src/world_entities/npcs/ground_turret.h
===================================================================
--- /branches/network/src/world_entities/npcs/ground_turret.h	(revision 7443)
+++ /branches/network/src/world_entities/npcs/ground_turret.h	(revision 7444)
@@ -30,7 +30,4 @@
   virtual void tick(float time);
 
-  virtual int writeBytes(const byte* data, int length, int sender);
-  virtual int readBytes(byte* data, int maxLength, int * reciever);
-
  private:
    PNode  weaponHolder[2];
Index: /branches/network/src/world_entities/playable.cc
===================================================================
--- /branches/network/src/world_entities/playable.cc	(revision 7443)
+++ /branches/network/src/world_entities/playable.cc	(revision 7444)
@@ -60,7 +60,8 @@
 
   this->score = 0;
-  this->oldScore = 0;
 
   this->bDead = false;
+  
+  registerVar( new SynchronizeableInt( &score, &score, "score" ) );
 }
 
@@ -480,79 +481,4 @@
 
 
-#define DATA_FLAGS    1
-#define DATA_SCORE    2
-
-#define FLAGS_bFire   1
-
-int Playable::writeSync( const byte * data, int length, int sender )
-{
-  SYNCHELP_READ_BEGIN();
-
-  byte b;
-  SYNCHELP_READ_BYTE( b, NWT_PL_B );
-
-  byte flags;
-
-  if ( b == DATA_FLAGS )
-  {
-    SYNCHELP_READ_BYTE( flags, NWT_PL_FLAGS );
-
-    bFire = (flags & FLAGS_bFire) != 0;
-
-    return SYNCHELP_READ_N;
-  }
-
-  if ( b == DATA_SCORE )
-  {
-    int newScore;
-    SYNCHELP_READ_BYTE( newScore, NWT_PL_SCORE );
-    setScore( newScore );
-
-    return SYNCHELP_READ_N;
-  }
-
-  return SYNCHELP_READ_N;
-}
-
-int Playable::readSync( byte * data, int maxLength )
-{
-  SYNCHELP_WRITE_BEGIN();
-
-  if ( score != oldScore && isServer() )
-  {
-    SYNCHELP_WRITE_BYTE( DATA_SCORE, NWT_PL_B);
-    SYNCHELP_WRITE_INT( score, NWT_PL_SCORE );
-    oldScore = score;
-
-    return SYNCHELP_WRITE_N;
-  }
-
-  byte flags = 0;
-
-  if ( bFire )
-    flags |= FLAGS_bFire;
-
-
-  SYNCHELP_WRITE_BYTE( DATA_FLAGS, NWT_PL_B);
-  SYNCHELP_WRITE_BYTE( flags, NWT_PL_FLAGS );
-  oldFlags = flags;
-
-
-  return SYNCHELP_WRITE_N;
-}
-
-bool Playable::needsReadSync( )
-{
-  if ( score != oldScore && isServer() )
-    return true;
-
-  byte flags = 0;
-
-  if ( bFire )
-    flags |= FLAGS_bFire;
-
-  return flags!=oldFlags;
-}
-
 
 /**
Index: /branches/network/src/world_entities/playable.h
===================================================================
--- /branches/network/src/world_entities/playable.h	(revision 7443)
+++ /branches/network/src/world_entities/playable.h	(revision 7444)
@@ -79,10 +79,4 @@
   virtual void tick(float dt);
 
-  // NETWORK
-  int       writeSync(const byte* data, int length, int sender);
-  int       readSync(byte* data, int maxLength );
-  bool      needsReadSync();
-
-
   // Transformations:
   static Playable::Playmode stringToPlaymode(const std::string& playmode);
@@ -111,6 +105,5 @@
   int                   oldFlags;           //!< Used for synchronisation
 
-  int                   score;
-  int                   oldScore;
+  int                   score;              //!< players score
 
   bool                  bDead;
Index: /branches/network/src/world_entities/power_ups/laser_power_up.cc
===================================================================
--- /branches/network/src/world_entities/power_ups/laser_power_up.cc	(revision 7443)
+++ /branches/network/src/world_entities/power_ups/laser_power_up.cc	(revision 7444)
@@ -120,40 +120,3 @@
 }
 
-int LaserPowerUp::writeBytes( const byte * data, int length, int sender )
-{
-  setRequestedSync( false );
-  setIsOutOfSync( false );
 
-  SYNCHELP_READ_BEGIN();
-
-  SYNCHELP_READ_FKT( PowerUp::writeState, NWT_LPU_WE_STATE );
-
-  return SYNCHELP_READ_N;
-}
-
-
-
-int LaserPowerUp::readBytes( byte * data, int maxLength, int * reciever )
-{
-  if ( isOutOfSync() && !requestedSync() && this->getHostID()!=this->getOwner() )
-  {
-    (NetworkGameManager::getInstance())->sync( this->getUniqueID(), this->getOwner() );
-    setRequestedSync( true );
-  }
-
-  int rec = this->getRequestSync();
-  if ( rec > 0 )
-  {
-    *reciever = rec;
-
-    SYNCHELP_WRITE_BEGIN();
-
-    SYNCHELP_WRITE_FKT( PowerUp::readState, NWT_LPU_WE_STATE );
-
-    return SYNCHELP_WRITE_N;
-  }
-
-  *reciever = 0;
-  return 0;
-}
-
Index: /branches/network/src/world_entities/power_ups/laser_power_up.h
===================================================================
--- /branches/network/src/world_entities/power_ups/laser_power_up.h	(revision 7443)
+++ /branches/network/src/world_entities/power_ups/laser_power_up.h	(revision 7444)
@@ -26,7 +26,4 @@
   virtual void draw() const;
 
-  virtual int writeBytes(const byte* data, int length, int sender);
-  virtual int readBytes(byte* data, int maxLength, int * reciever );
-
   private:
    void init();
Index: /branches/network/src/world_entities/power_ups/param_power_up.cc
===================================================================
--- /branches/network/src/world_entities/power_ups/param_power_up.cc	(revision 7443)
+++ /branches/network/src/world_entities/power_ups/param_power_up.cc	(revision 7444)
@@ -43,4 +43,9 @@
   if( root != NULL)
     this->loadParams(root);
+  
+  registerVar( new SynchronizeableInt( (int*)&type, (int*)&type, "type" ) );
+  registerVar( new SynchronizeableFloat( &value, &value, "value" ) );
+  registerVar( new SynchronizeableFloat( &max_value, &max_value, "max_value" ) );
+  registerVar( new SynchronizeableFloat( &min_value, &min_value, "min_value" ) );
 }
 
@@ -119,62 +124,2 @@
 }
 
-int ParamPowerUp::writeBytes( const byte * data, int length, int sender )
-{
-  setRequestedSync( false );
-  setIsOutOfSync( false );
-
-  SYNCHELP_READ_BEGIN();
-
-  SYNCHELP_READ_FKT( PowerUp::writeState, NWT_PPU_WE_STATE );
-
-  int i;
-  SYNCHELP_READ_INT( i, NWT_PPU_TYPE );
-  this->type = (EnumParamPowerUpType)i;
-  SYNCHELP_READ_FLOAT( this->value, NWT_PPU_VALUE );
-
-  if ( this->value != 0 )
-  {
-    SYNCHELP_READ_FLOAT( this->min_value, NWT_PPU_MINVALUE );
-    SYNCHELP_READ_FLOAT( this->max_value, NWT_PPU_MAXVALUE );
-    respawn();
-  }
-
-  return SYNCHELP_READ_N;
-}
-
-
-
-int ParamPowerUp::readBytes( byte * data, int maxLength, int * reciever )
-{
-  if ( isOutOfSync() && !requestedSync() && this->getHostID()!=this->getOwner() )
-  {
-    (NetworkGameManager::getInstance())->sync( this->getUniqueID(), this->getOwner() );
-    setRequestedSync( true );
-  }
-
-  int rec = this->getRequestSync();
-  if ( rec > 0 )
-  {
-    *reciever = rec;
-
-    SYNCHELP_WRITE_BEGIN();
-
-    SYNCHELP_WRITE_FKT( PowerUp::readState, NWT_PPU_WE_STATE );
-
-    int i = (int)this->type;
-    SYNCHELP_WRITE_INT( i, NWT_PPU_TYPE );
-    SYNCHELP_WRITE_FLOAT( this->value, NWT_PPU_VALUE );
-
-    if ( this->value != 0 )
-    {
-      SYNCHELP_WRITE_FLOAT( this->min_value, NWT_PPU_MINVALUE );
-      SYNCHELP_WRITE_FLOAT( this->max_value, NWT_PPU_MAXVALUE );
-    }
-
-    return SYNCHELP_WRITE_N;
-  }
-
-  *reciever = 0;
-  return 0;
-}
-
Index: /branches/network/src/world_entities/power_ups/param_power_up.h
===================================================================
--- /branches/network/src/world_entities/power_ups/param_power_up.h	(revision 7443)
+++ /branches/network/src/world_entities/power_ups/param_power_up.h	(revision 7444)
@@ -32,7 +32,4 @@
   float getValue();
 
-  virtual int writeBytes(const byte* data, int length, int sender);
-  virtual int readBytes(byte* data, int maxLength, int * reciever );
-
 protected:
   virtual void respawn();
Index: /branches/network/src/world_entities/power_ups/power_up.cc
===================================================================
--- /branches/network/src/world_entities/power_ups/power_up.cc	(revision 7443)
+++ /branches/network/src/world_entities/power_ups/power_up.cc	(revision 7444)
@@ -201,34 +201,2 @@
 
 
-/********************************************************************************************
- NETWORK STUFF
- ********************************************************************************************/
-
-
-/**
- * data copied in data will bee sent to another host
- * @param data pointer to data
- * @param maxLength max length of data
- * @return the number of bytes writen
- */
-int PowerUp::readState( byte * data, int maxLength )
-{
-  SYNCHELP_WRITE_BEGIN();
-  SYNCHELP_WRITE_FKT( WorldEntity::readState, NWT_PU_WE_STATE );
-  return SYNCHELP_WRITE_N;
-}
-
-
-/**
- * Writes data from network containing information about the state
- * @param data pointer to data
- * @param length length of data
- * @param sender hostID of sender
- */
-int PowerUp::writeState( const byte * data, int length, int sender )
-{
-  SYNCHELP_READ_BEGIN();
-  SYNCHELP_READ_FKT( WorldEntity::writeState, NWT_PU_WE_STATE );
-  return SYNCHELP_READ_N;
-}
-
Index: /branches/network/src/world_entities/power_ups/power_up.h
===================================================================
--- /branches/network/src/world_entities/power_ups/power_up.h	(revision 7443)
+++ /branches/network/src/world_entities/power_ups/power_up.h	(revision 7444)
@@ -34,7 +34,4 @@
   void setRespawnTime(const float respawn);
 
-  int       writeState(const byte* data, int length, int sender);
-  int       readState(byte* data, int maxLength );
-
 protected:
   PowerUp(float r, float g, float b);
Index: /branches/network/src/world_entities/power_ups/turret_power_up.cc
===================================================================
--- /branches/network/src/world_entities/power_ups/turret_power_up.cc	(revision 7443)
+++ /branches/network/src/world_entities/power_ups/turret_power_up.cc	(revision 7444)
@@ -115,47 +115,2 @@
   glPopMatrix();
 }
-
-
-
-
-/********************************************************************************************
- NETWORK STUFF
- ********************************************************************************************/
-
-
-int TurretPowerUp::writeBytes( const byte * data, int length, int sender )
-{
-  setRequestedSync( false );
-  setIsOutOfSync( false );
-
-  SYNCHELP_READ_BEGIN();
-
-  SYNCHELP_READ_FKT( PowerUp::writeState, NWT_TPU_WE_STATE );
-
-  return SYNCHELP_READ_N;
-}
-
-
-int TurretPowerUp::readBytes( byte * data, int maxLength, int * reciever )
-{
-  if ( isOutOfSync() && !requestedSync() && this->getHostID()!=this->getOwner() )
-  {
-    (NetworkGameManager::getInstance())->sync( this->getUniqueID(), this->getOwner() );
-    setRequestedSync( true );
-  }
-
-  int rec = this->getRequestSync();
-  if ( rec > 0 )
-  {
-    *reciever = rec;
-
-    SYNCHELP_WRITE_BEGIN();
-
-    SYNCHELP_WRITE_FKT( PowerUp::readState, NWT_TPU_WE_STATE );
-
-    return SYNCHELP_WRITE_N;
-  }
-
-  *reciever = 0;
-  return 0;
-}
Index: /branches/network/src/world_entities/power_ups/turret_power_up.h
===================================================================
--- /branches/network/src/world_entities/power_ups/turret_power_up.h	(revision 7443)
+++ /branches/network/src/world_entities/power_ups/turret_power_up.h	(revision 7444)
@@ -24,7 +24,4 @@
   virtual void draw() const;
 
-  virtual int writeBytes(const byte* data, int length, int sender);
-  virtual int readBytes(byte* data, int maxLength, int * reciever );
-
   private:
    void init();
Index: /branches/network/src/world_entities/power_ups/weapon_power_up.cc
===================================================================
--- /branches/network/src/world_entities/power_ups/weapon_power_up.cc	(revision 7443)
+++ /branches/network/src/world_entities/power_ups/weapon_power_up.cc	(revision 7444)
@@ -103,43 +103,2 @@
 }
 
-int WeaponPowerUp::writeBytes( const byte * data, int length, int sender )
-{
-  setRequestedSync( false );
-  setIsOutOfSync( false );
-
-  SYNCHELP_READ_BEGIN();
-
-  SYNCHELP_READ_FKT( PowerUp::writeState, NWT_WPU_WE_STATE );
-
-  //TODO: sync weapon class ( see loadParams )
-
-  return SYNCHELP_READ_N;
-}
-
-
-
-int WeaponPowerUp::readBytes( byte * data, int maxLength, int * reciever )
-{
-  if ( isOutOfSync() && !requestedSync() && this->getHostID()!=this->getOwner() )
-  {
-    (NetworkGameManager::getInstance())->sync( this->getUniqueID(), this->getOwner() );
-    setRequestedSync( true );
-  }
-
-  int rec = this->getRequestSync();
-  if ( rec > 0 )
-  {
-    *reciever = rec;
-
-    SYNCHELP_WRITE_BEGIN();
-
-    SYNCHELP_WRITE_FKT( PowerUp::readState, NWT_WPU_WE_STATE );
-
-    //TODO: sync weapon class ( see loadParams )
-
-    return SYNCHELP_WRITE_N;
-  }
-
-  *reciever = 0;
-  return 0;
-}
Index: /branches/network/src/world_entities/power_ups/weapon_power_up.h
===================================================================
--- /branches/network/src/world_entities/power_ups/weapon_power_up.h	(revision 7443)
+++ /branches/network/src/world_entities/power_ups/weapon_power_up.h	(revision 7444)
@@ -24,7 +24,4 @@
   void setWeaponClass(const std::string& name);
 
-  virtual int writeBytes(const byte* data, int length, int sender);
-  virtual int readBytes(byte* data, int maxLength, int * reciever );
-
   bool process(WeaponManager* manager);
 
Index: /branches/network/src/world_entities/skybox.cc
===================================================================
--- /branches/network/src/world_entities/skybox.cc	(revision 7443)
+++ /branches/network/src/world_entities/skybox.cc	(revision 7444)
@@ -95,4 +95,7 @@
 {
   this->rebuild();
+  
+  textureName_handle = registerVarId( new SynchronizeableString( &textureName, &textureName, "textureName") );
+  size_handle = registerVarId( new SynchronizeableFloat( &size, &size, "size" ) );
 }
 
@@ -292,62 +295,6 @@
 }
 
-int SkyBox::writeBytes( const byte * data, int length, int sender )
-{
-  setRequestedSync( false );
-  setIsOutOfSync( false );
-
-  SYNCHELP_READ_BEGIN();
-
-  SYNCHELP_READ_FKT( WorldEntity::writeState, NWT_SB_WE_STATE );
-
-  SYNCHELP_READ_FLOAT( size, NWT_SB_SIZE );
-  if ( !this->textureName.empty() )
-  {
-    textureName = "";
-  }
-  std::string texName;
-  SYNCHELP_READ_STRING( texName, NWT_SB_TEXTURENAME );
-
-  this->setSize( size );
-  this->setTextureAndType( texName, "jpg" );
-  this->rebuild();
-
-  return SYNCHELP_READ_N;
-}
-
-
-
-int SkyBox::readBytes( byte * data, int maxLength, int * reciever )
-{
-  if ( isOutOfSync() && !requestedSync() && this->getHostID()!=this->getOwner() )
-  {
-    (NetworkGameManager::getInstance())->sync( this->getUniqueID(), this->getOwner() );
-    setRequestedSync( true );
-  }
-
-  int rec = this->getRequestSync();
-  if ( rec > 0 )
-  {
-    *reciever = rec;
-
-    SYNCHELP_WRITE_BEGIN();
-
-    SYNCHELP_WRITE_FKT( WorldEntity::readState, NWT_SB_WE_STATE );
-
-    SYNCHELP_WRITE_FLOAT(this->size, NWT_SB_SIZE);
-    SYNCHELP_WRITE_STRING(this->textureName, NWT_SB_TEXTURENAME);
-
-    return SYNCHELP_WRITE_N;
-  }
-
-  *reciever = 0;
-  return 0;
-}
-
-void SkyBox::writeDebug( ) const
-{
-}
-
-void SkyBox::readDebug( ) const
-{
-}
+void SkyBox::varChangeHandler( std::list< int > & id )
+{
+#warning implement this
+}
Index: /branches/network/src/world_entities/skybox.h
===================================================================
--- /branches/network/src/world_entities/skybox.h	(revision 7443)
+++ /branches/network/src/world_entities/skybox.h	(revision 7444)
@@ -58,8 +58,5 @@
   static void disableCubeMap();
 
-  virtual int       writeBytes(const byte* data, int length, int sender);
-  virtual int       readBytes(byte* data, int maxLength, int * reciever);
-  virtual void      writeDebug() const;
-  virtual void      readDebug() const;
+  virtual void varChangeHandler( std::list<int> & id );
 
  private:
@@ -72,4 +69,7 @@
   float           textureSize;     //!< this is the length of a texture (assumes a square texture)
   std::string     textureName;     //!< Name of the Texture
+  
+  int textureName_handle;          //!< used to notify about changes of textureName
+  int size_handle;                 //!< used to notify about changes of size
 
 };
